;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%;
;    V. 0.3 (x) 2004                               ;
;        DIEHARD                 ;
;                                                         ;
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%;
; :		[0..eax-1]                                             ;
;------------------------------------------------------------------------------;
; :        call	r_init                                         ;
;			mov	eax,                           ;
;			call	brandom32                                      ;
;------------------------------------------------------------------------------;
; :		   [0.. ]               ;
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%;

;----[    ]-------------------;

r_init:
		push	ebp eax edx		;    ebp,
						; eax, edx

		call	__delta1_		;
__delta1_:	pop	ebp			;   
		sub	ebp,offset __delta1_	;

		db	0fh,031h		;   
		mov	rand_seed,eax		;

		pop	edx eax ebp		;  edx,
						; eax, ebp

		ret				;   

;----[     ]----------------------;

brandom32:					;  
						;   
						;   0..eax-1

		push	edx ecx	ebp		;    edx,
						; ecx, ebp

		call	__delta2_		;
__delta2_:	pop	ebp			;   
		sub	ebp,offset __delta2_	;

		imul	eax,eax,100		;  eax  100
		push	eax			;   eax  

		call	random32		;  
						;   
		xor	edx,edx			;  edx
		pop	ecx			;  
						;    ecx
		div	ecx			;  eax  ecx
		xchg	eax,edx			;    eax
		xor	edx,edx			;  edx
		push	100			;   ecx - 100
		pop	ecx			;
		div	ecx			;  eax  ecx
		pop	ebp ecx edx		;  ebp, ecx,
						; edx
		ret				;   

;----[   ]---------------------------------;

random32:
		push	ebp

		call	
__delta3_		;
__delta3_:	pop	ebp			;   
		sub	ebp,offset __delta3_	;

                mov     eax,12345678h		;
		rand_seed= dword ptr $-4	;
		imul	eax,00019660Dh		;
		add	eax,03C6EF35Fh		;  
		mov     [ebp+rand_seed],eax	;   
		shr     eax,16			; 
		imul    eax,[esp+4]		;

		pop	ebp

		retn				;   
